| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Private Member Functions | Private Attributes | List of all members
Genfun::GaudiMathImplementation::GSLFunctionWithMode Class Reference

`#include <GaudiMath/GSLFunAdapters.h>`

Inheritance diagram for Genfun::GaudiMathImplementation::GSLFunctionWithMode:
[legend]
Collaboration diagram for Genfun::GaudiMathImplementation::GSLFunctionWithMode:
[legend]

## Public Types
typedef double(* | Function) (double, gsl_mode_t)
| the actual type of the function More...

## Public Member Functions
| GSLFunctionWithMode (Function fun, const gsl_mode_t &mode)
| mandatory macro from CLHEP/GenericFunctions More...
| GSLFunctionWithMode (const GSLFunctionWithMode &)
| copy constructor More...
virtual | ~GSLFunctionWithMode ()=default
| destructor More...
virtual double | operator() (double x) const
| the main method More...
virtual double | operator() (const Argument &x) const
virtual bool | hasAnalyticDerivative () const
virtual unsigned int | dimensionality () const
Genfun::Derivative | partial (unsigned int i) const
Function | function () const
| get the function itself More...
const gsl_mode_t & | mode () const
| get the current mode More...

## Private Member Functions
| GSLFunctionWithMode ()
GSLFunctionWithMode & | operator= (const GSLFunctionWithError &)

## Private Attributes
Function | m_function
gsl_mode_t * | m_mode

## Detailed Description

Definition at line 70 of file GSLFunAdapters.h.

## Member Typedef Documentation

typedef double(* Genfun::GaudiMathImplementation::GSLFunctionWithMode::Function) (double, gsl_mode_t)

the actual type of the function

Definition at line 74 of file GSLFunAdapters.h.

## Constructor & Destructor Documentation

Genfun::GaudiMathImplementation::GSLFunctionWithMode::GSLFunctionWithMode | ( | GSLFunctionWithMode::Function | function,
|  | const gsl_mode_t & | mode
| ) |  |

mandatory macro from CLHEP/GenericFunctions

constructor with pointer to function

Definition at line 89 of file GSLFunAdapters.cpp.

91 : AbsFunction()
92 , m_function ( function )
93 , m_mode ( new gsl_mode_t() )
94 {
95 *m_mode = mod ;
96 }
Gaudi.CommonGaudiConfigurables.mod
tuple mod
Definition: CommonGaudiConfigurables.py:22
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
gsl_mode_t * m_mode
Definition: GSLFunAdapters.h:103
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:102

Genfun::GaudiMathImplementation::GSLFunctionWithMode::GSLFunctionWithMode | ( | const GSLFunctionWithMode & | func | ) |

copy constructor

Definition at line 99 of file GSLFunAdapters.cpp.

100 : AbsFunction()
101 , m_function ( func.m_function )
102 , m_mode ( new gsl_mode_t () )
103 {
104 *m_mode = *(func.m_mode) ;
105 }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
gsl_mode_t * m_mode
Definition: GSLFunAdapters.h:103
GaudiPluginService.cpluginsvc.func
tuple func
Definition: cpluginsvc.py:218
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:102

virtual Genfun::GaudiMathImplementation::GSLFunctionWithMode::~GSLFunctionWithMode | ( |  | ) |
| virtual default

destructor

Genfun::GaudiMathImplementation::GSLFunctionWithMode::GSLFunctionWithMode | ( |  | ) |
| private

## Member Function Documentation

virtual unsigned int Genfun::GaudiMathImplementation::GSLFunctionWithMode::dimensionality | ( |  | ) | const
| inline virtual

Definition at line 90 of file GSLFunAdapters.h.

90 { return 1 ; }

GSLFunctionWithMode::Function Genfun::GaudiMathImplementation::GSLFunctionWithMode::function | ( |  | ) | const

get the function itself

Definition at line 127 of file GSLFunAdapters.cpp.

128 { return m_function ; }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:102

virtual bool Genfun::GaudiMathImplementation::GSLFunctionWithMode::hasAnalyticDerivative | ( |  | ) | const
| inline virtual

Definition at line 89 of file GSLFunAdapters.h.

89 { return true ; }

const gsl_mode_t & Genfun::GaudiMathImplementation::GSLFunctionWithMode::mode | ( |  | ) | const

get the current mode

Definition at line 130 of file GSLFunAdapters.cpp.

131 { return *m_mode ; }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
gsl_mode_t * m_mode
Definition: GSLFunAdapters.h:103

double Genfun::GaudiMathImplementation::GSLFunctionWithMode::operator() | ( | double | x | ) | const
| virtual

the main method

Definition at line 108 of file GSLFunAdapters.cpp.

109 { return (*m_function)( x , *m_mode ) ; }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
gsl_mode_t * m_mode
Definition: GSLFunAdapters.h:103
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:102

virtual double Genfun::GaudiMathImplementation::GSLFunctionWithMode::operator() | ( | const Argument & | x | ) | const
| virtual

GSLFunctionWithMode& Genfun::GaudiMathImplementation::GSLFunctionWithMode::operator= | ( | const GSLFunctionWithError & |  | ) |
| private

Genfun::Derivative Genfun::GaudiMathImplementation::GSLFunctionWithMode::partial | ( | unsigned int | i | ) | const

Definition at line 116 of file GSLFunAdapters.cpp.

117 {
118 if( i >= 1 )
119 {
120 const AbsFunction& aux = GaudiMath::Constant( 0 , 1 ) ;
121 return Genfun::FunctionNoop( &aux ) ;
122 };
123 const AbsFunction& aux = GaudiMath::Derivative( *this , i) ;
124 return Genfun::FunctionNoop( &aux ) ;
125 }
GaudiMath::Derivative
Genfun::GaudiMathImplementation::NumericalDerivative Derivative
Definition: GaudiMath.h:29
ana.i
list i
Definition: ana.py:128
GaudiMath::Constant
Genfun::GaudiMathImplementation::Constant Constant
Definition: GaudiMath.h:27

## Member Data Documentation

Function Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
| private

Definition at line 102 of file GSLFunAdapters.h.

gsl_mode_t* Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
| private

Definition at line 103 of file GSLFunAdapters.h.

The documentation for this class was generated from the following files:

- GaudiGSL/GaudiMath/GSLFunAdapters.h
- GaudiGSL/src/Lib/GSLFunAdapters.cpp